-- 25.07.2016 19:09:59.674 Statement #1, start at Row #1
-- Kalender
create table cal_L_Weekday(
  ID int not null,
  Token varchar(5) not null,
  Name varchar(35) not null,
  constraint calWeekday_PK primary key (ID)
);
-- 25.07.2016 19:09:59.679 0,01 sec elapsed

-- 25.07.2016 19:09:59.680 Statement #2, start at Row #9
create table cal_L_Month(
  ID int not null,
  Token varchar(5) not null,
  Name varchar(35) not null,
  constraint calMonth primary key (ID)
);
-- 25.07.2016 19:09:59.682 0,00 sec elapsed

-- 25.07.2016 19:09:59.682 Statement #3, start at Row #16
create table cal_S_Day(
  ID int not null,
  Date_ date not null,
  WeekdayNo int not null,
  WeekYearNo int not null,
  WeekNo int not null,
  WeekToken varchar(10) not null,  -- z.B. '2013-08'
  DayInMonth int not null,
  MonthNo int not null,
  DayNo int not null,
  QuaterNo int not null,
  YearNo int not null,
  IsWorkDay bit not null,
  IsWeekend bit not null,
  IsHolyday bit not null,
  IsBridgDay bit not null,
  constraint calDay_PK primary key (ID),
  constraint calDay_FK_Weekday foreign key (WeekdayNo) references cal_L_Weekday(ID),
  constraint calDay_FK_Month foreign key (MonthNo) references cal_L_Month(ID)
);
-- 25.07.2016 19:09:59.686 0,00 sec elapsed

-- 25.07.2016 19:09:59.686 Statement #4, start at Row #37
create index calDay_SI_Weekday on cal_S_Day(WeekdayNo);
-- 25.07.2016 19:09:59.687 0,00 sec elapsed

-- 25.07.2016 19:09:59.688 Statement #5, start at Row #38
create unique index calDay_SI_Day on cal_S_Day(DayNo, YearNo);
-- 25.07.2016 19:09:59.689 0,00 sec elapsed

-- 25.07.2016 19:09:59.689 Statement #6, start at Row #39
create index calDay_SI_Week on cal_S_Day(WeekNo, YearNo);
-- 25.07.2016 19:09:59.690 0,00 sec elapsed

-- 25.07.2016 19:09:59.691 Statement #7, start at Row #40
create index calDay_SI_WeekYear on cal_S_Day(WeekNo, WeekYearNo);
-- 25.07.2016 19:09:59.692 0,00 sec elapsed

-- 25.07.2016 19:09:59.692 Statement #8, start at Row #41
create index calDay_SI_Month on cal_S_Day(MonthNo, YearNo);
-- 25.07.2016 19:09:59.693 0,00 sec elapsed

-- 25.07.2016 19:09:59.693 Statement #9, start at Row #42
create index calDay_SI_Year on cal_S_Day(YearNo);
-- 25.07.2016 19:09:59.694 0,00 sec elapsed

-- 25.07.2016 19:09:59.694 Statement #10, start at Row #44
create table cal_L_Time_Type(
  ID varchar(5) not null,
  Token varchar(5) not null,
  Name varchar(35) not null,
  Is_Typical_Worktime bit not null constraint calDaytimeType_Def_TypWT default 0,
  constraint calDatimeType_PK primary key (ID)
);
-- 25.07.2016 19:09:59.697 0,00 sec elapsed

-- 25.07.2016 19:09:59.697 Statement #11, start at Row #52
create table cal_L_Daytime(
  ID int not null,         -- Zeit als sprechende Zahl im Format 'hhmmss'
  T_HH time not null,      -- Zeit im Format 'hh:00:00' (angefangene Stunde)
  T_HHMM time not null,    -- Zeit im Format 'hh:mm:00' (angefangene Minute)
  T_HHMMSS time not null,  -- Zeit im Format 'hh:mm:ss'
  DT datetime not null,    -- Datum/Zeit ab Tag 0
  Hour_ int not null,       -- Stunde als Integer von T_HHMMSS
  Minute_ int not null,     -- Minute als Integer von T_HHMMSS
  Second_ int not null,     -- Sekunde als Integer von T_HHMMSS
  Abs_Hour int not null,   -- Anzahl Stunden seit ID = 0 (kann auch negativ werden)
  Abs_Minute int not null, -- Anzahl Minuten seit ID = 0 (kann auch negativ werden)
  Abs_Second int not null, -- Anzahl Sekunden seit ID = 0 (kann auch negativ werden)
  ID_Time_Type varchar(5) null,
  constraint calTime_PK primary key (ID),
  constraint calTime_FK_TimeType foreign key (ID_Time_Type) references cal_L_Time_Type(ID)
);
-- 25.07.2016 19:09:59.700 0,00 sec elapsed

-- 25.07.2016 19:09:59.700 Statement #12, start at Row #69
create index calDaytime_IX_TimeType on cal_L_Daytime (ID_Time_Type);
-- 25.07.2016 19:09:59.701 0,00 sec elapsed

-- 25.07.2016 19:09:59.701 Statement #13, start at Row #70
create unique index calDaytime_IX_AbsSecond on cal_L_Daytime (Abs_Second);
-- 25.07.2016 19:09:59.702 0,00 sec elapsed

-- 25.07.2016 19:09:59.702 Statement #14, start at Row #72
create table inv_K_VAT_Type (
  ID varchar(2) not null,
  Token varchar(30) not null,
  Description varchar(2048) null,
  constraint invVATType_PK primary key (ID)
)
-- 25.07.2016 19:09:59.705 0,00 sec elapsed

-- 25.07.2016 19:09:59.705 Statement #15, start at Row #80
create table inv_K_VAT (
  ID varchar(10) not null,
  ID_VATType varchar(2) null,
  Valid_Beg int not null,
  Valid_End int null,
  Value_ Money not null,
  constraint invVAT_PK primary key (ID),
  constraint invVAT_FK_invVATType foreign key (ID_VATType) references inv_K_VAT_Type (ID)
)
create index invVAT_SI_invVATType on inv_K_VAT (ID_VATType);
-- 25.07.2016 19:09:59.708 0,00 sec elapsed

-- 25.07.2016 19:09:59.708 Statement #16, start at Row #93
create table obj_L_Type(
  ID varchar(5) not null,
  Name varchar(50) not null,
  constraint objType_PK primary key (ID)
);
-- 25.07.2016 19:09:59.710 0,00 sec elapsed

-- 25.07.2016 19:09:59.711 Statement #17, start at Row #99
create table obj_S_Base (
  ID int identity(1,1),
  ID_Type varchar(5) not null,
  ID_VATType varchar(2) null,
  Number varchar(30) not null,
  Name varchar(50) not null,
  Description varchar(2048) null,
  constraint objBase_PK primary key (ID),
  constraint objBase_FK_Type foreign key (ID_Type) references obj_L_Type(ID),
  constraint objBase_FK_invVATType foreign key (ID_VATType) references inv_K_VAT_Type (ID)
);
-- 25.07.2016 19:09:59.713 0,00 sec elapsed

-- 25.07.2016 19:09:59.714 Statement #18, start at Row #111
create index objBse_SI_Type on obj_S_Base(ID_Type);
-- 25.07.2016 19:09:59.715 0,00 sec elapsed

-- 25.07.2016 19:09:59.715 Statement #19, start at Row #112
create index objBase_SI_invVATType on obj_S_Base (ID_VATType);
-- 25.07.2016 19:09:59.716 0,00 sec elapsed

-- 25.07.2016 19:09:59.717 Statement #20, start at Row #115
create table obj_S_Inventory(
  ID int not null,
  Number_Serial varchar(30) not null,
  constraint objInventory_PK primary key (ID),
  constraint objInventory_FK_Base foreign key (ID) references obj_S_Base (ID)
);
-- 25.07.2016 19:09:59.719 0,00 sec elapsed

