// ============================================================================
//
// Unit:    ibeDataObjectManager
// Inhalt:  Formular
// Aufgabe: Factory fr DataObjects
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit ibeDataObjectManager;

interface

uses
  SysUtils,
  ibeDALConnection, ibeDataObject;

type

TibeDataObjectManager = class
private
protected
public
  function CreateInstance(AConnection: TibeDALConnection; ADOClass: TibeDataObjectClass): TibeDataObject;
end;

implementation

function TibeDataObjectManager.CreateInstance(AConnection: TibeDALConnection; ADOClass: TibeDataObjectClass): TibeDataObject;
var
  LDO: TibeDataObject;
begin
  LDO := ADOClass.Create(AConnection);
  try
  
  except
    FreeAndNil(LDO);
    raise;
  end;

  Result := LDO;
end;

end.
