// ============================================================================
//
// Unit:    ibeFCommon
// Inhalt:  Formular
// Aufgabe: Basisformular
//
//   (c) by Klaus Etscheid since 2016
// ============================================================================
unit ibeFCommon;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList,
  ibeAppServiceProvider;

type
  TfrmCommon = class(TForm)
    alMain: TActionList;
    procedure FormCreate(Sender: TObject);
  private
		function GetASP: TibeAppServiceProvider;
  protected
    procedure InternalInit; virtual;
    function GetShortCaption: string; virtual;
	public
		property ASP: TibeAppServiceProvider read GetASP;
    property ShortCaption: string read GetShortCaption;
    procedure DisplayInContainer(a_ctlParent: TWinControl);
	end;

TfrmCommonClass = class of TfrmCommon;

implementation

{$R *.dfm}

procedure TfrmCommon.DisplayInContainer(a_ctlParent: TWinControl);
begin
  BorderStyle := bsNone;
  Parent := a_ctlParent;
  Show;
  Align := alClient;
end;

procedure TfrmCommon.FormCreate(Sender: TObject);
begin
  InternalInit;
end;

procedure TfrmCommon.InternalInit;
begin
end;

function TfrmCommon.GetASP: TibeAppServiceProvider;
begin
	Result := RetrieveASP;
end;

function TfrmCommon.GetShortCaption: string;
begin
  Result := Caption;
end;

end.
