// ============================================================================
//
// Unit:    ibeFCommonDODialog
// Inhalt:  Formular
// Aufgabe: Basisformular fr Dialoge mit DataObject
//
//   (c) by Klaus Etscheid since 2016
// ============================================================================
unit ibeFCommonDODialog;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, pngimage, ExtCtrls, 
  ibeFCommonDialog,
  ibeAppServiceProviderDB, ibeDALConnection;

type
  TibeFrmCommonDODialog = class(TfrmCommonDialog)
  private
    function GetConnection: TibeDALConnection;
		function GetASP: TibeAppServiceProviderDB;
  protected
    procedure InternalActionOK(); override;
  public
    property Connection: TibeDALConnection read GetConnection;
		property ASP: TibeAppServiceProviderDB read GetASP;
  end;

implementation

{$R *.dfm}

procedure TibeFrmCommonDODialog.InternalActionOK();
begin
  ASP.Connection.TranStart();
  try
    if ActionOK() then
    begin
      ModalResult := mrOk;
    end;

    ASP.Connection.TranCommit();
  except
    on E: Exception do
    begin
      ASP.Connection.TranRollback(E);
    end;
  end;
end;

function TibeFrmCommonDODialog.GetConnection: TibeDALConnection;
begin
  Result := ASP.Connection;
end;

function TibeFrmCommonDODialog.GetASP: TibeAppServiceProviderDB;
begin
	Result := RetrieveASP;
end;

end.

