// ============================================================================
//
// Unit:    ibeFCommonEditHost
// Inhalt:  Formular
// Aufgabe: Basisformular das als Host fr Bearbeutungsformular dient
//
//   (c) by Klaus Etscheid since 2016
// ============================================================================
unit ibeFCommonEditHost;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, ActnList, StdCtrls, ExtCtrls, 
  ibeFCommon,
  ibeFCommonEdit;

type
  TibeFrmCommonEditHost = class(TfrmCommon)
    actOK: TAction;
    actCancel: TAction;
    procedure actOKExecute(Sender: TObject);
    procedure actCancelExecute(Sender: TObject);
  private
    FFrmEdit: TibeFrmCommonEdit;
    FPKValue: Variant;
    //function GetFrmEditClass(): TibeFrmCommonEditClass;
    //procedure SetFrmEditClass(AFormEditClass: TibeFrmCommonEditClass);
  protected
    property FrmEdit: TibeFrmCommonEdit read FFrmEdit;
    function RetrieveEditFormContainer(): TWinControl; virtual; abstract;
    function RetrieveFormClientWidth(): Integer; virtual; abstract;
    function RetrieveFormClientHeight(): Integer; virtual; abstract;
  public
    procedure ActionBrowse();
    procedure ActionEdit();
    procedure ActionNew();
    property PKValue: Variant read FPKValue write FPKValue;
    //property FrmEditClass: TibeFrmCommonEditClass read GetFrmEditClass write SetFrmEditClass;
    procedure CreateEditForm(AFormEditClass: TibeFrmCommonEditClass; out AEditForm: TibeFrmCommonEdit);
  end;

TibeFrmCommonEditHostClass = class of TibeFrmCommonEditHost;

implementation

uses
  ibeException;

{$R *.dfm}

procedure TibeFrmCommonEditHost.ActionBrowse();
begin
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionEdit(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.PKValue := PKValue;
  FrmEdit.ActionBrowse();

  ShowModal;
end;

procedure TibeFrmCommonEditHost.ActionEdit();
begin
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionEdit(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.PKValue := PKValue;
  FrmEdit.ActionEdit();

  ShowModal;
end;

procedure TibeFrmCommonEditHost.ActionNew();
begin
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionEdit(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.ActionNew();

  ShowModal;
end;

procedure TibeFrmCommonEditHost.CreateEditForm(AFormEditClass: TibeFrmCommonEditClass; out AEditForm: TibeFrmCommonEdit);
begin
  if Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.SetFrmEditClass(): es gibt bereits ein Bearbeitungsfenster, die Klasse kann nicht zugewiesen werden');
  end;

  if not Assigned(AFormEditClass) then
  begin
    raise EibeException.Create(Self, 'EditHost.SetFrmEditClass(): die Klasse fr das Bearbeitungsformular muss eine Ableitung von TibeFrmCommonEdit sein');
  end;

  FFrmEdit := AFormEditClass.Create(Self);

  ClientWidth := RetrieveFormClientWidth();
  ClientHeight := RetrieveFormClientHeight();

  FrmEdit.DisplayInContainer(RetrieveEditFormContainer());
  FrmEdit.Show();

  AEditForm := FrmEdit;
end;

//function TibeFrmCommonEditHost.GetFrmEditClass(): TibeFrmCommonEditClass;
//begin
//  Result := TibeFrmCommonEditClass(FrmEdit.ClassType);
//end;
//
//procedure TibeFrmCommonEditHost.SetFrmEditClass(AFormEditClass: TibeFrmCommonEditClass);
//begin
//  if Assigned(FrmEdit) then
//  begin
//    raise EibeException.Create(Self, 'EditHost.SetFrmEditClass(): es gibt bereits ein Bearbeitungsfenster, die Klasse kann nicht zugewiesen werden');
//  end;
//
//  if not Assigned(AFormEditClass) then
//  begin
//    raise EibeException.Create(Self, 'EditHost.SetFrmEditClass(): die Klasse fr das Bearbeitungsformular muss eine Ableitung von TibeFrmCommonEdit sein');
//  end;
//
//  FFrmEdit := AFormEditClass.Create(Self);
//
//  ClientWidth := RetrieveFormClientWidth();
//  ClientHeight := RetrieveFormClientHeight();
//
//  FrmEdit.DisplayInContainer(RetrieveEditFormContainer());
//  FrmEdit.Show();
//end;

procedure TibeFrmCommonEditHost.actCancelExecute(Sender: TObject);
begin
  inherited;
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionCancel(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.ActionCancel();

  ModalResult := mrCancel;
end;

procedure TibeFrmCommonEditHost.actOKExecute(Sender: TObject);
begin
  inherited;
  if not Assigned(FrmEdit) then
  begin
    raise EibeException.Create(Self, 'EditHost.ActionSave(): die Klasse fr das Bearbeitungsformular wurde nicht eingetragen');
  end;

  FrmEdit.ActionSave();
  PKValue := FrmEdit.PKValue;

  ModalResult := mrOk;
end;

end.

