// ============================================================================
//
// Unit:    ibeLogfile
// Inhalt:  Formular
// Aufgabe: Klassenbibliothek zum schreiben in Protokolldateien
//
//   (c) by Klaus Etscheid since 2016
// ============================================================================
unit ibeLogfile;

interface

uses
  SysUtils, Classes;

type

TibeLogFile = class
private
  FFileName: TFileName;
protected
public
  constructor Create(const AFileName: TFileName);
  procedure Write(const AMessage: string);
  property FileName: TFileName read FFileName;
end;

implementation

constructor TibeLogFile.Create(const AFileName: TFileName);
begin
  inherited Create();

  FFileName := AFileName;
end;

procedure TibeLogFile.Write(const AMessage: string);
var
  LOpenMode: Integer;
  LStream: TFileStream;
begin
  if FileExists(FileName) then
  begin
    LOpenMode := fmOpenWrite;
  end else
  begin
    LOpenMode := fmCreate;
  end;
  
  LStream := TFileStream.Create(FileName, LOpenMode or fmShareDenyWrite);
  try
    // den Stream ans Ende positionieren
    LStream.Seek(0, soEnd);
    // einen Zeilenmbruch anhngen
    LStream.Write(#13#10, SizeOf(Char) * 2);
    if AMessage <> '' then
    begin
      // die Message in den Stream schreiben
      LStream.Write(AMessage[1], SizeOf(AMessage[1]) * Length(AMessage));
    end;
  finally
    FreeAndNil(LStream);
  end;
end;

end.
