// ============================================================================
//
// Unit:    invDOKVAT
// Inhalt:  Formular
// Aufgabe: Datenobjekt fr Testkatalog Umsatzsteuerstze
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit invDOKVAT;

interface

uses
  Variants,
  ibeDALConnection, ibeDataObject, ibeDataObjectTypes;

type

TinvDOKVAT = class(TibeDataObject)
private
protected
public
  function FetchByDueDate(const AVatTypeID: string; ADueDate: TDateTime): Boolean;
  procedure FilterAddVatType(const AVatTypeID: string);
  procedure FilterAddDueDate(ADueDate: TDateTime);
  procedure GroupByVatType();
  procedure AddViewGroupByVatType();
end;

implementation

function TinvDOKVAT.FetchByDueDate(const AVatTypeID: string; ADueDate: TDateTime): Boolean;
begin
  FilterClear();
  FilterAddVatType(AVatTypeID);
  FilterAddDueDate(ADueDate);

  Refresh();

  Result := RecordCount = 1;
end;

procedure TinvDOKVAT.FilterAddVatType(const AVatTypeID: string);
begin
  FilterAdd('Vat_ID_VATType', AVatTypeID);
end;

procedure TinvDOKVAT.FilterAddDueDate(ADueDate: TDateTime);
var
  LFilterBeg, LFilterEnd: string;
begin
  LFilterBeg := FilterBuild('Vat_Valid_Beg', ADueDate, '<=');
  
  LFilterEnd := FilterBuild('Vat_Valid_End', ADueDate, '>=') + ' or ' + FilterBuild('Vat_Valid_End', Null);
  FilterAdd(LFilterBeg + ' and (' + LFilterEnd + ')');
end;

procedure TinvDOKVAT.GroupByVatType();
begin
  DODef.SelectActiveView('GroupByVatType');
end;

procedure TinvDOKVAT.AddViewGroupByVatType();
begin
  DODef.AddView('Dynamisch');
  DODef.AddViewField('VatType_Token', '');
  DODef.AddViewField('VatType_Token', '', doafCount);
  DODef.AddViewField('Vat_Value_', '', doafMin);
  DODef.AddViewField('Vat_Value_', '', doafMax);
  DODef.AddViewField('Vat_Value_', '', doafSum);
  DODef.AddViewField('Vat_Value_', '', doafAvg);

  DODef.AddViewGroupByField('VatType_Token');
end;

end.
