// ============================================================================
//
// Unit:    TestDAL_ADO_MSSQL
// Inhalt:  DUnit Test
// Aufgabe: Testflle DAL-Bibliothek fr MS SQL Server mit ADO Komponenten
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit TestDAL_ADO_MSSQL;
{

  Delphi DUnit Testfall
  ----------------------
  Diese Unit enthlt ein Codegerst einer Testfallklasse, das vom Testfall-Experten
  erzeugt wurde. ndern Sie den erzeugten Code, damit die Methoden aus der 
  getesteten Unit korrekt eingerichtet und aufgerufen werden.

}
interface

uses
  SysUtils,
  TestFramework, 
  TestDataAccessObject,
  ibeDALConnection, ibeDALQuery;

type

TestTibeDAL_ADO_MSSQL = class(TestTibeDataAccessObject)
private
protected
  function InternalTestDAOTempTableHandling(AConnection: TibeDALConnection): Boolean; override;
public
  constructor Create(AMethodName: string); override;
published
end;
  
implementation

constructor TestTibeDAL_ADO_MSSQL.Create(AMethodName: string); 
begin
  inherited Create(AMethodName);

  IBEConnectionName := 'TestDAL-ADO-MSSQL';
  DBName := 'TEST_DAL';

  InitScriptDDL := '..\Config\DBScript\Simple DDL Script (MSSQL).sql';
  InitScriptDML := '..\Config\DBScript\Simple DML Script.sql';
end;

function TestTibeDAL_ADO_MSSQL.InternalTestDAOTempTableHandling(AConnection: TibeDALConnection): Boolean;
var
  LQuery: TibeDALQuery;
begin
  LQuery := AConnection.DAOQueryCreate();
  try
    CheckNotNull(LQuery, 'Query');

    CheckFalse(AConnection.RetrieveTempTableExists('#meine'), 'Existenz Temp-Tabelle #meine prfen');
      
    LQuery.SQL := 'create table #meine(id int not null)';
    LQuery.Execute();

    CheckTrue(AConnection.RetrieveTempTableExists('#meine'), 'Existenz Temp-Tabelle #meine prfen');
  finally
    FreeAndNil(LQuery);
  end;

  Result := True;
end;

initialization

  // Alle Testflle beim Test-Runner registrieren
  RegisterTest(TestTibeDAL_ADO_MSSQL.Suite);

end.
