unit DMTestMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs,
  ibeAppServiceProviderDB;

type
  TmodTestMain = class(TDataModule)
    procedure DataModuleDestroy(Sender: TObject);
    procedure DataModuleCreate(Sender: TObject);
  private
		FAutoConnect: Boolean;
		FASP: TibeAppServiceProviderDB;
  protected
    procedure DoBeforeOpenConnectionMain(); virtual;
		function InternalExecute(): Boolean; virtual;
		property AutoConnect: Boolean read FAutoConnect write FAutoConnect;
  public
		function ActionStartup(): Boolean;
		property ASP: TibeAppServiceProviderDB read FASP;
  end;

var
  modTestMain: TmodTestMain;

implementation

uses
  ibeAppServiceProvider;

{$R *.dfm}

function TmodTestMain.ActionStartup(): Boolean;
var bOK: Boolean;
begin
	bOK := True;

	if bOK then begin
		FASP := TibeAppServiceProviderDB.Create();
    StoreASP(ASP);
    ASP.AppExeName := Application.ExeName;
    ASP.Owner := Self;
	end;

	if bOK then begin
		ASP.InitMainConnection;
  end;

	if bOK and AutoConnect then begin
    DoBeforeOpenConnectionMain();
    
    ASP.Connection.Open;
	end;

	if bOK then begin
		bOK := InternalExecute;
	end;

	Result := bOK;
end;

procedure TmodTestMain.DataModuleCreate(Sender: TObject);
begin
	AutoConnect	:= False;
end;

procedure TmodTestMain.DataModuleDestroy(Sender: TObject);
begin
  StoreASP(nil);
  FASP := nil;
end;

function TmodTestMain.InternalExecute(): Boolean;
begin
	Result := True;
end;

procedure TmodTestMain.DoBeforeOpenConnectionMain();
begin
//  if not ASP.Connection.DatabaseExists(ASP.Connection.InitialDatabase) then
//  begin
//    ASP.Connection.DatabaseCreate(ASP.Connection.InitialDatabase);
//  end;
end;

end.
