// ============================================================================
//
// Unit:    TestDataObjectCreateDatabase
// Inhalt:  Formular
// Aufgabe: DUnit Test fr das Anlegen der Datenbank
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit TestDataObjectCreateDatabase;
{

  Delphi DUnit Testfall
  ----------------------
  Diese Unit enthlt ein Codegerst einer Testfallklasse, das vom Testfall-Experten
  erzeugt wurde. ndern Sie den erzeugten Code, damit die Methoden aus der 
  getesteten Unit korrekt eingerichtet und aufgerufen werden.

}

interface

uses
  TestFramework, SysUtils, Classes,
  ibeString,
  ibeDALConnection, ibeDALConnectionManager, ibeDALQuery, ibeTypes;

type
// Testmethoden fr Klasse TibeDataObjectDefinition
  
TestTibeDataObjectCreateDatabase = class(TTestCase)
strict private
protected
public
  constructor Create(AMethodName: string); override;
  procedure SetUp(); override;
  procedure TearDown(); override;
published
  procedure TestExecuteCreateScripts();
end;

implementation

uses
  ibeAppServiceProviderDB, ibeSQLScript;

constructor TestTibeDataObjectCreateDatabase.Create(AMethodName: string); 
begin
  inherited Create(AMethodName);
end;

procedure TestTibeDataObjectCreateDatabase.SetUp; 
begin
end;

procedure TestTibeDataObjectCreateDatabase.TearDown; 
begin
end;

procedure TestTibeDataObjectCreateDatabase.TestExecuteCreateScripts();
var
  LDatabaseName, LTestDatabaseName, LScriptName, LDBMSName: string;
  LFileName: TFileName;
  LScript: TibeSQLScript;
begin
  LDatabaseName := RetrieveASP.Connection.ActiveDatabase;
  LTestDatabaseName := RetrieveASP.Connection.Parameters.Values['TestDatabaseName'];

  if LTestDatabaseName <> '' then
  begin
    if LTestDatabaseName <> LDatabaseName then
    begin
      LDatabaseName := LTestDatabaseName;
    end;
  end;
  
  // eine existierende Datenbank ggf. erst lschen, dann die Datenbank neu anlegen
  if RetrieveASP.Connection.DatabaseExists(LDatabaseName) then
  begin
    RetrieveASP.Connection.DatabaseDrop(LDatabaseName);
  end;
  
  RetrieveASP.Connection.DatabaseCreate(LDatabaseName);
  if RetrieveASP.Connection.ActiveDatabase <> LDatabaseName then
  begin
    RetrieveASP.Connection.ActiveDatabase := LDatabaseName;
  end;

  LScript := TibeSQLScript.Create(RetrieveASP.Connection);
  try
    // das Create-Screipt fr das jeweilige Datenbanksystem ausfhren
    LDBMSName := RetrieveASP.Connection.DBMSName;
    LFileName := AddBackslash(RetrieveASP.CfgPath) + Format('DBScript\Create ibeV2Dev Database DDL (%s).sql', [LDBMSName]);
    LScript.FileName := LFileName;
    LScript.Execute();

    // die noch leere Datenbank mit dem Script fr Testdaten fllen
    LFileName := AddBackslash(RetrieveASP.CfgPath) + 'DBScript\Create ibeV2Dev Database DML.sql';
    LScript.FileName := LFileName;
    LScript.Execute();
  finally
    FreeAndNil(LScript);
  end;

  CheckTrue(True, 'Fehler');
end;

initialization

  // Alle Testflle beim Test-Runner registrieren
  RegisterTest(TestTibeDataObjectCreateDatabase.Suite);

end.
