// ============================================================================
//
// Unit:    TestDataObjectManager
// Inhalt:  Formular
// Aufgabe: DUnit Test fr den Datenobjekt Manager
//
//   (c) by Klaus Etscheid since 2015
// ============================================================================
unit TestDataObjectManager;
{

  Delphi DUnit Testfall
  ----------------------
  Diese Unit enthlt ein Codegerst einer Testfallklasse, das vom Testfall-Experten
  erzeugt wurde. ndern Sie den erzeugten Code, damit die Methoden aus der 
  getesteten Unit korrekt eingerichtet und aufgerufen werden.

}

interface

uses
  TestFramework, SysUtils, 
  ibeDataObjectManager, ibeDataObject,
  objDOBase;

type
  // Testmethoden fr Klasse TibeDataObjectManager
  
  TestTibeDataObjectManager = class(TTestCase)
  strict private
    FibeDataObjectManager: TibeDataObjectManager;
  public
    procedure SetUp; override;
    procedure TearDown; override;
  published
    procedure TestCreateInstance;
  end;

implementation

uses
  ibeAppServiceProvider, ibeAppServiceProviderDB;

procedure TestTibeDataObjectManager.SetUp;
begin
  FibeDataObjectManager := TibeDataObjectManager.Create();
end;

procedure TestTibeDataObjectManager.TearDown;
begin
  FibeDataObjectManager.Free;
  FibeDataObjectManager := nil;
end;

procedure TestTibeDataObjectManager.TestCreateInstance;
var
  ReturnValue: TibeDataObject;
begin
  ReturnValue := FibeDataObjectManager.CreateInstance(RetrieveASP.Connection, TobjDOBase);
  try
    CheckNotNull(ReturnValue, 'Fehler beim Aufruf von CreateInstance fr DO objBase');
  finally
    FreeAndNil(ReturnValue);
  end;
  // TODO: Methodenergebnisse prfen
end;

initialization
  // Alle Testflle beim Test-Runner registrieren
  RegisterTest(TestTibeDataObjectManager.Suite);
end.

